
res_x=1024
res_y=768

require("mundo")
require("jogador")
require("moeda")
require("efeitos")
require("inimigo")
require("chave")
require("diamante")
require("tempo")

gravidade=.50
tempo_tiro=love.timer.getMicroTime()

paused=false
exibe_mapa=false
move_mapa=""
ambiente=""
campo_visao=0
tempo_trovao={}
tempo_trovao[0]=0
tempo_trovao[1]=0
tempo_trovao[2]=0

nuvem={}

function love.load()

	math.randomseed(os.time())
	math.random()
	math.random()
	math.random()

	x=math.random(1,5)
	if x==1 then
		ambiente="sol"
	elseif x==2 then
		ambiente="nublado"
	elseif x==3 then
		ambiente="chuva"
	elseif x==4 then
		ambiente="noite"
	elseif x==5 then
		ambiente="noite_chuva"
	end

	ok=love.graphics.setMode(res_x,res_y,false,false)

	love.mouse.setVisible(false)

	tempo_frame=0

	jogador:new(fase)
	tempo:ceus()
	tempo:nuvens()

	res_x=1708
	res_y=1281

	mundo:reset()

	print(ambiente)
end

function love.update(dt)
	if not paused and not exibe_mapa and not jogador.game_over then
		if 	tempo_frame==0 then
			key=""
			if love.keyboard.isDown("left") then
				key="left"
			elseif love.keyboard.isDown("right") then
				key="right"
			end
			if jogador.posicao_colisao=="on_top" and (love.keyboard.isDown("up") or jogador.pulo==1) then
				key="up_"..key
			end
			jogador:control(key)
			moeda:testa_colisao_mundo()
			inimigo:testa_colisao_mundo()
			chave:testa_colisao_jogador()
			chave:cria_efeito()
			jogador:checa_atualiza_mundo()
			if jogador.atualiza_mundo_x==true then
				mundo:atualiza_posicao_x()
				moeda:atualiza_posicao_x()
				efeito:atualiza_posicao_x()
				inimigo:atualiza_posicao_x()
				chave:atualiza_posicao_x()
				diamante:atualiza_posicao_x()
			end
			jogador:atualiza_posicao()

			if #nuvem>0 then
				for i=1,#nuvem do
					n=nuvem[i]
					n.x=n.x+n.vel_x
					if n.vel_x<0 and n.x+n.img:getWidth()<mundo[1].x then
						n.x=n.x+80
						n.y=math.random(mundo[1].y,mundo[1].y+150)
					end
					if n.vel_x>0 and n.x>mundo[#mundo].x+80 then
						n.x=mundo[1].x-(n.img:getWidth()+10)
						n.y=math.random(mundo[1].y,mundo[1].y+150)
					end
					if jogador.atualiza_mundo_x==true then
						if string.find(jogador.direcao,"right")~=nil then
							n.x=n.x-6
						elseif string.find(jogador.direcao,"left")~=nil then
							n.x=n.x+6
						end
					end
					dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,n.x,n.y)))
					if dist<=300 then
						n.alfa=255
						n.mapa_visivel=true
					else
						dif=dist-300
						n.alfa=255-dif
						if n.alfa<=0 then n.alfa=0 end
					end
				end
			end
		end
		tempo_frame=tempo_frame+dt
		if tempo_frame>=.02 then
			tempo_frame=0
		end
	end
end

function love.draw()

	t=0
	if love.timer.getFPS()<150 then t=2 end
	if love.timer.getFPS()<100 then t=4 end

	love.graphics.clear()
	love.graphics.scale(0.60,0.60)

	if exibe_mapa==false then
		love.graphics.setColor(255,255,255,255)
		love.graphics.setBackgroundColor(0,0,0)
		love.graphics.draw(img_ceu,0,0,0,200,1)
		love.graphics.draw(img_fundo,0,600,0,200,1.13)
		for i=0,2 do
			if love.timer.getMicroTime()>=tempo_trovao[i]-.15 then
				love.graphics.setBackgroundColor(255,255,255)
				if love.timer.getMicroTime()>=tempo_trovao[i] then
					tempo_trovao[i]=love.timer.getMicroTime()+math.random(4,8)
				end
			end
		end


		if #nuvem>0 then
			for i=1,#nuvem do
				n=nuvem[i]
				love.graphics.setColor(255,255,255,n.alfa)
				love.graphics.draw(n.img,n.x,n.y)
			end
		end

		love.graphics.setColor(255,255,255,255)

		if jogador.vivo==true then jogador:draw() end
		inimigo:draw()
		mundo:draw(t)
		moeda:draw()
		chave:draw()
		if jogador.vivo==false then jogador:draw() end
		mundo:exibe_icones()
		efeito:draw()
		diamante:draw()

		if string.find(ambiente,"chuva")~=nil then
			tempo:draw()
		end


		love.graphics.setColor(255,255,255)
		love.graphics.scale(2,2)
		if paused then
			love.graphics.print("Game paused",5,20)
		elseif jogador.game_over then
			love.graphics.print("Game Over. Press F2 to restart.",5,20)
		end

		love.graphics.print(love.timer.getFPS(),5,40)
	else
		mundo:exibe_mapa()
	end

end

function love.keyreleased(key)
	if jogador.pulo==0 then
		jogador.frame=0
	end
	jogador.tempo_frame=0
	move_mapa=""
end

function love.keypressed(key, unicode)

	if not jogador.game_over then
		if key=="escape" then
			love.event.quit()
		end
		if key=="pause" then
			paused=not paused
		end
		if key=="tab" then
			exibe_mapa=not exibe_mapa
		end
		if exibe_mapa then
			if key=="left" then
				move_mapa="left"
			elseif key=="right"then
				move_mapa="right"
			end
		end
		if key=="f10" then
			ok=love.graphics.toggleFullscreen()
			tempo:ceus()
		end
	else
		if key=="f2" then

			jogador:new(fase)

			res_x=1708
			res_y=1281

			mundo:apaga()
			mundo:reset()

		end
	end
end

function love.mousepressed(x, y, k)

end

function love.mousereleased(x, y, k)

end

function checa_colisao(ax1,ay1,aw,ah, bx1,by1,bw,bh)
	local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh

	return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function math.dist(x1,y1, x2,y2)
	return ((x2-x1)^2+(y2-y1)^2)^0.5
end

function love.focus(hasFocus)
	if not hasFocus then
		paused=true
	else
		paused=false
	end
end
